/*
mlp_nn_lm.hh

This C++ header file defines the class MLP_NN_LM_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
Fri Dec 22 17:42:35 EST 2000	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef MLP_NN_LM_HH
#define MLP_NN_LM_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "mlp_lm.hh" // MLP_LM definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "mlp_nn_lmn.hh" 	// NML Commands and Status definitions for mlp_nn_lm
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class MLP_NN_LM_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	MLP_NN_LM_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(MLP_NN_LM_INIT *);
	virtual void HALT(MLP_NN_LM_HALT *);
	virtual void SET_ACTIVATION_FUNCTION_TYPE(MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE *);
	virtual void SET_INPUT_BIASES(MLP_NN_LM_SET_INPUT_BIASES *);
	virtual void SET_INPUT_GAINS(MLP_NN_LM_SET_INPUT_GAINS *);
	virtual void SET_NONSINGULARITY_PARAM(MLP_NN_LM_SET_NONSINGULARITY_PARAM *);
	virtual void SET_OUTPUT_BIASES(MLP_NN_LM_SET_OUTPUT_BIASES *);
	virtual void SET_OUTPUT_GAINS(MLP_NN_LM_SET_OUTPUT_GAINS *);
	virtual void TEST(MLP_NN_LM_TEST *);
	virtual void TRAIN(MLP_NN_LM_TRAIN *);

	// Convenience Variables
	MLP_NN_LM_STATUS *mlp_nn_lm_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int num_of_inputs;
  int num_of_outputs;
  int num_of_neurons;
  int num_of_data;

  MLP_LM *mlp_lm;

  double sys_inputs[NUM_OF_INPUTS];
  double sys_outputs[NUM_OF_OUTPUTS];
  double ref_outputs[NUM_OF_OUTPUTS];

  double output_errors[NUM_OF_OUTPUTS];

  double **batch_inputs;
  double **batch_ref_outputs;

  double **temp1;
  double **temp2;

};

#endif 	// MLP_NN_LM_HH

